/*
 File: term_def_ph.h
 Date and Time: Fri Jan 30 18:55:26 2015 
*/
#ifndef __term_def_ph_h__
#define __term_def_ph_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "lint_balls.h"
#include "identifier.h"
#include "c_string.h"
#include "t_def_delabort_tags.h"
#include "terminal_def_symclass.h"
#include "o2_sdc.h"
#include "yacco2_stbl.h"
#include "o2_externs.h"
#include "cweb_or_c_k.h"

  
extern yacco2::Thread_entry ITH_term_def_ph;

extern yacco2::State S1_Cterm_def_ph;
namespace NS_term_def_ph {
yacco2::THR _YACCO2_CALL_TYPE
TH_term_def_ph(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_term_def_ph(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[16];
};
class Cterm_def_ph: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rterminal_def_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_Rterminal_def_phrase_ = 1
   ,R_Rid_ = 570//start_of_rule_list + 2
    ,rhs1_Rid_ = 2
    ,rhs2_Rid_ = 3
    ,rhs3_Rid_ = 4
    ,rhs4_Rid_ = 5
    ,rhs5_Rid_ = 6
    ,rhs6_Rid_ = 7
    ,rhs7_Rid_ = 8
   ,R_Rad_ab_tags_ = 571//start_of_rule_list + 4
    ,rhs1_Rad_ab_tags_ = 9
    ,rhs2_Rad_ab_tags_ = 10
    ,rhs3_Rad_ab_tags_ = 11
   ,R_Rad_ab_tag_ = 572//start_of_rule_list + 6
    ,rhs1_Rad_ab_tag_ = 12
    ,rhs2_Rad_ab_tag_ = 13
   ,R_Rsym_cweb_k_ = 573//start_of_rule_list + 8
    ,rhs1_Rsym_cweb_k_ = 14
    ,rhs2_Rsym_cweb_k_ = 15
    ,rhs3_Rsym_cweb_k_ = 16
   ,R_Rsym_class_phrase_ = 574//start_of_rule_list + 10
    ,rhs1_Rsym_class_phrase_ = 17
   ,R_Rsym_class_ = 575//start_of_rule_list + 12
    ,rhs1_Rsym_class_ = 18
    ,rhs2_Rsym_class_ = 19
   ,R_Rsym_class_id_ = 576//start_of_rule_list + 14
    ,rhs1_Rsym_class_id_ = 20
    ,rhs2_Rsym_class_id_ = 21
    ,rhs3_Rsym_class_id_ = 22
   ,R_Rpotential_code_blk_ = 577//start_of_rule_list + 16
    ,rhs1_Rpotential_code_blk_ = 23
    ,rhs2_Rpotential_code_blk_ = 24
   ,R_Ropen_par_ = 578//start_of_rule_list + 18
    ,rhs1_Ropen_par_ = 25
    ,rhs2_Ropen_par_ = 26
   ,R_Rclose_par_ = 579//start_of_rule_list + 20
    ,rhs1_Rclose_par_ = 27
    ,rhs2_Rclose_par_ = 28
   ,R_Rclosing_brace_ = 580//start_of_rule_list + 22
    ,rhs1_Rclosing_brace_ = 29
    ,rhs2_Rclosing_brace_ = 30
   ,R_Rdirectives_ = 581//start_of_rule_list + 24
    ,rhs1_Rdirectives_ = 31
    ,rhs2_Rdirectives_ = 32
   ,R_Rdirective_ = 582//start_of_rule_list + 26
    ,rhs1_Rdirective_ = 33
    ,rhs2_Rdirective_ = 34
    ,rhs3_Rdirective_ = 35
    ,rhs4_Rdirective_ = 36
    ,rhs5_Rdirective_ = 37
    ,rhs6_Rdirective_ = 38
   ,R_Rsyntax_code_ = 583//start_of_rule_list + 28
    ,rhs1_Rsyntax_code_ = 39
    ,rhs2_Rsyntax_code_ = 40
   ,R_Rlint_ = 584//start_of_rule_list + 30
    ,rhs1_Rlint_ = 41
    ,rhs2_Rlint_ = 42
  };
  //no of la sets = 10
  //no of states = 75
  Cterm_def_ph();
  ~Cterm_def_ph();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[43];
  
    public:
    void add_sdc_to_directive(CAbs_lr1_sym* Dir,T_syntax_code* Sdc);
    T_terminal_def* term_def_;
  
 };
struct Rterminal_def_phrase;
struct Rid;
struct Rad_ab_tags;
struct Rad_ab_tag;
struct Rsym_cweb_k;
struct Rsym_class_phrase;
struct Rsym_class;
struct Rsym_class_id;
struct Rpotential_code_blk;
struct Ropen_par;
struct Rclose_par;
struct Rclosing_brace;
struct Rdirectives;
struct Rdirective;
struct Rsyntax_code;
struct Rlint;
struct Rterminal_def_phrase:public yacco2::CAbs_lr1_sym {
  Rterminal_def_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rid:public yacco2::CAbs_lr1_sym {
  Rid(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr7();
};

struct Rad_ab_tags:public yacco2::CAbs_lr1_sym {
  Rad_ab_tags(yacco2::Parser* P);
  public:
};

struct Rad_ab_tag:public yacco2::CAbs_lr1_sym {
  Rad_ab_tag(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rsym_cweb_k:public yacco2::CAbs_lr1_sym {
  Rsym_cweb_k(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rsym_class_phrase:public yacco2::CAbs_lr1_sym {
  Rsym_class_phrase(yacco2::Parser* P);
  public:
};

struct Rsym_class:public yacco2::CAbs_lr1_sym {
  Rsym_class(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rsym_class_id:public yacco2::CAbs_lr1_sym {
  Rsym_class_id(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rpotential_code_blk:public yacco2::CAbs_lr1_sym {
  Rpotential_code_blk(yacco2::Parser* P);
  public:
};

struct Ropen_par:public yacco2::CAbs_lr1_sym {
  Ropen_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_par:public yacco2::CAbs_lr1_sym {
  Rclose_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclosing_brace:public yacco2::CAbs_lr1_sym {
  Rclosing_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rdirectives:public yacco2::CAbs_lr1_sym {
  Rdirectives(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
};

struct Rdirective:public yacco2::CAbs_lr1_sym {
  Rdirective(yacco2::Parser* P);
  void op();

    CAbs_lr1_sym* directive_;
  
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
};

struct Rsyntax_code:public yacco2::CAbs_lr1_sym {
  Rsyntax_code(yacco2::Parser* P);

    T_syntax_code* syntax_code_;
  
  public:
  void sr1();
  void sr2();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

} // end of namespace

#endif
